﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.IO;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace MvcApplication3.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            ViewBag.Message = "Modify this template to jump-start your ASP.NET MVC application.";

            return View();
        }

        [HttpPost]
        public ActionResult Upload()
        {
            foreach (string item in Request.Files)
            {
                HttpPostedFileBase postFile = Request.Files[item];
                if (postFile.ContentLength == 0)
                    continue;

                string newFilePath = Request.ApplicationPath + "UploadFile/" + string.Format("{0:yyyyMMdd}", DateTime.Today);
                if (!System.IO.Directory.Exists(Server.MapPath(newFilePath)))
                {
                    System.IO.Directory.CreateDirectory(Server.MapPath(newFilePath));
                }

                ViewData["FilePath"] = newFilePath + "/" + string.Format("{0:hhmmss}", DateTime.Now) + "." + postFile.FileName.Split('.').Last();
                postFile.SaveAs(Server.MapPath(newFilePath) + "/" + string.Format("{0:hhmmss}", DateTime.Now) + "." + postFile.FileName.Split('.').Last());

            }
            return View("Index");
        }

        [HttpPost]
        public ActionResult Uploadify(int h=300, int w=300)
        {
            string filePath = "";
            foreach (string item in Request.Files)
            {
                HttpPostedFileBase postFile = Request.Files[item];
                if (postFile.ContentLength == 0)
                    continue;
                string newFilePath = Request.ApplicationPath + "UploadFile/" + string.Format("{0:yyyyMMdd}", DateTime.Today);
                if (!System.IO.Directory.Exists(Server.MapPath(newFilePath)))
                {
                    System.IO.Directory.CreateDirectory(Server.MapPath(newFilePath));
                }
                string file = newFilePath + "/" + string.Format("{0:hhmmss}", DateTime.Now) +"_"+ System.Guid.NewGuid() + "." + postFile.FileName.Split('.').Last();
                filePath = file;
                Image imageFile = resizeImage(Image.FromStream(postFile.InputStream, true, true), new Size { Height = h, Width = w });
                //postFile.SaveAs(Server.MapPath(file));
                imageFile.Save(Server.MapPath(file));
            }
            return Content(filePath);
        }

        private static Image resizeImage(Image imgToResize, Size size)
        {
            int sourceWidth = imgToResize.Width;
            int sourceHeight = imgToResize.Height;

            float nPercent = 0;
            float nPercentW = 0;
            float nPercentH = 0;

            nPercentW = ((float)size.Width / (float)sourceWidth);
            nPercentH = ((float)size.Height / (float)sourceHeight);

            if (nPercentH < nPercentW)
                nPercent = nPercentH;
            else
                nPercent = nPercentW;

            int destWidth = (int)(sourceWidth * nPercent);
            int destHeight = (int)(sourceHeight * nPercent);

            Bitmap b = new Bitmap(destWidth, destHeight);
            Graphics g = Graphics.FromImage((Image)b);
            g.InterpolationMode = InterpolationMode.HighQualityBicubic;

            g.DrawImage(imgToResize, 0, 0, destWidth, destHeight);
            g.Dispose();

            return (Image)b;
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your app description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}
